VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CAction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mcolMembers As Collection

Public Sub Action(ByVal oCode As CodeModule, _
                        ByVal DoAction As ActionType, _
                        ByVal Inc As Increments _
                        )
                        
'This sub is used to evaluate all line of the passed code module and
'change or leave that line according to the action specified.
    
    Dim oMember As CMember
    Dim oEvalLine As CEvalLine
    Dim lngCnt As Long
    
    
    On Error GoTo Errhandler
    'Check that the passed action is valid
    Select Case DoAction
        Case actAdd, actRemove
        Case Else
            Err.Raise 13
    End Select
    
'    MakeMemberCollection oCode  'adds CMember object to a collection
'
'    If mcolMembers.Count > 0 Then
'        Set oEvalLine = New CEvalLine
'    End If
'
'    'This is where the line evaluation goes
'    oEvalLine.Increment = Inc
'
'    For Each oMember In mcolMembers
''        Debug.Print oMember.MemberName, oMember.ProcType, oMember.StartLn, oMember.Length
'
'
'        'step thru each line of the code and check if action should be taken
'        For lngCnt = oMember.StartLn To (oMember.StartLn + oMember.Length)
'            'Debug.Print oMember.MemberName, oMember.StartLn, oMember.StartLn + oMember.Length
'
'            If oEvalLine.EvaluateLine(oCode.Lines(lngCnt, 1), DoAction) = rtnChanged Then
''                Debug.Print oEvalLine.NewLine
'                oCode.ReplaceLine lngCnt, oEvalLine.NewLine
'            End If
'
'
'        Next lngCnt
'    Next

    If oCode.CountOfLines > 0 Then
        Set oEvalLine = New CEvalLine
        oEvalLine.Increment = Inc
        
        For lngCnt = 1 To oCode.CountOfLines
           
           If oEvalLine.EvaluateLine(oCode.Lines(lngCnt, 1), DoAction) = rtnChanged Then
                'Debug.Print oEvalLine.NewLine
                oCode.ReplaceLine lngCnt, oEvalLine.NewLine
            End If
            
        Next lngCnt
        
    End If
    
    Set oEvalLine = Nothing
    Set oMember = Nothing
    
Exit Sub

Errhandler:
    
    Debug.Assert Err.Number = 0
    
Resume Next

End Sub

Private Sub MakeMemberCollection(ByVal oCode As CodeModule)
    'This module is used to add all the method, property get/let/set procedure information
    'to a CMember object and add that object to a collection for later processing
        
    Dim oCodeMem As Member
    
    Dim oMem As CMember
    Dim oTempMem As CMember
    Dim intCnt As Integer
    Dim blnPlaced As Boolean
    Dim intPropType As Integer
    Dim lngStartLn  As Long
    
    On Error GoTo Errhandler

    If mcolMembers Is Nothing Then
        Set mcolMembers = New Collection
    End If
    
    For Each oCodeMem In oCode.Members

        Select Case oCodeMem.Type
            Case vbext_mt_Method
                                 
                Set oMem = New CMember
                
                With oMem
                    .MemberName = oCodeMem.Name
                    .StartLn = oCode.ProcStartLine(oCodeMem.Name, vbext_pk_Proc)
                    .Length = oCode.ProcCountLines(oCodeMem.Name, vbext_pk_Proc)
                    .ProcType = vbext_pk_Proc
                End With
                'add it to the collection
                'mcolMembers.Add oMem, oCodeMem.Name & " " & CStr(vbext_pk_Proc)
                If mcolMembers.Count = 0 Then
                    mcolMembers.Add oMem, oCodeMem.Name
                Else
                    For intCnt = 1 To mcolMembers.Count
                        Set oTempMem = mcolMembers(intCnt)
                        
                        If StrComp(oMem.MemberName, oTempMem.MemberName, vbTextCompare) = -1 Then
                            mcolMembers.Add oMem, oCodeMem.Name, intCnt
                            blnPlaced = True
                            Exit For
                        Else
                            blnPlaced = False
                        End If
                        
                    Next intCnt
                    
                    If Not blnPlaced Then   'if not added then add to end
                        mcolMembers.Add oMem, oCodeMem.Name, , mcolMembers.Count
                    End If
                End If
                    
            Case vbext_mt_Property
                
                On Error Resume Next
                
                For intPropType = vbext_pk_Let To vbext_pk_Get
                    'the following may cause an error if non-existent
                    lngStartLn = oCode.ProcStartLine(oCodeMem.Name, intPropType)
                    
                    If Err = 0 Then 'proceed only of property type exists
                        
                        Set oMem = New CMember
                        
                        With oMem
                            .MemberName = IIf(intPropType = vbext_pk_Let, "Let ", IIf(intPropType = vbext_pk_Get, "Get ", "Set ")) & oCodeMem.Name
                            .StartLn = oCode.ProcStartLine(oCodeMem.Name, intPropType)
                            .Length = oCode.ProcCountLines(oCodeMem.Name, intPropType)
                            .ProcType = intPropType
                        End With
                        'add it to the collection in alphabetical order by Name
                        If mcolMembers.Count = 0 Then
                            mcolMembers.Add oMem, oCodeMem.Name
                        Else
                            For intCnt = 1 To mcolMembers.Count
                                Set oTempMem = mcolMembers(intCnt)
                                
                                If StrComp(oMem.MemberName, oTempMem.MemberName, vbTextCompare) = -1 Then
                                    mcolMembers.Add oMem, oCodeMem.Name, intCnt
                                    blnPlaced = True
                                    Exit For
                                Else
                                    blnPlaced = False
                                End If
                                
                            Next intCnt
                            
                            If Not blnPlaced Then   'if not added then add to end
                                mcolMembers.Add oMem, oCodeMem.Name, , mcolMembers.Count
                            End If
                            
                        End If
                        
                    Else
                        Err.Clear   'reset error
                    End If
                
                Next intPropType    'try next property type
                
                On Error GoTo Errhandler
                
        End Select
    Next
    
    Set oCodeMem = Nothing
    Set oMem = Nothing
    
Exit Sub

Errhandler:

    Debug.Assert Err.Number = 0
    Resume Next
    
End Sub

