VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "VB Code Line Numbers Add/Remove"
Option Explicit

Implements IDTExtensibility

Public FormDisplayed          As Boolean
Public VBInstance             As VBIDE.VBE
Dim mcbMenuCommandBar         As Office.CommandBarControl
Dim mcbMenuEditCommandBar     As Office.CommandBarControl
Dim mfrmAddIn                 As New frmAddIn
Public WithEvents MenuHandler As CommandBarEvents          'command bar event handler
Attribute MenuHandler.VB_VarHelpID = -1
Public WithEvents MenuEditHandler As CommandBarEvents          'command bar event handler
Attribute MenuEditHandler.VB_VarHelpID = -1



Sub Hide()
    
    On Error Resume Next
    
    FormDisplayed = False
    mfrmAddIn.Hide
   
End Sub

Sub Show()
  
    On Error Resume Next
    
    If mfrmAddIn Is Nothing Then
        Set mfrmAddIn = New frmAddIn
    End If
    
    Set mfrmAddIn.VBInstance = VBInstance
    Set mfrmAddIn.Connect = Me
    FormDisplayed = True
    mfrmAddIn.Show
   
End Sub

'------------------------------------------------------
'this method adds the Add-In to VB
'------------------------------------------------------
Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBIDE.AddIn, custom() As Variant)
    
    On Error GoTo error_handler
    
    'save the vb instance
    Set VBInstance = VBInst
    
    'this is a good place to set a breakpoint and
    'test various addin objects, properties and methods
'    Debug.Print VBInst.FullName

    If ConnectMode = vbext_cm_External Then
        'Used by the wizard toolbar to start this wizard
        Me.Show
    Else
        Set mcbMenuCommandBar = AddToAddInCommandBar("Line Numbers", 101)
        'Dim mcbctl As Office.CommandBarControl
        'Set mcbctl =
        mcbMenuCommandBar.ToolTipText = "Add/Remove Line Numbers from your code."
        
        'sink the event
        Set Me.MenuHandler = VBInst.Events.CommandBarEvents(mcbMenuCommandBar)
        
        Set mcbMenuEditCommandBar = AddToEditCommandBar("Line Numbers", 101)
        
        mcbMenuEditCommandBar.ToolTipText = "Add/Remove Line Numbers from your code."
        
        'sink the event
        Set Me.MenuEditHandler = VBInst.Events.CommandBarEvents(mcbMenuEditCommandBar)

    End If
  
    If ConnectMode = vbext_cm_AfterStartup Then
        If GetSetting(App.Title, "Settings", "DisplayOnConnect", "0") = "1" Then
            'set this to display the form on connect
            Me.Show
        End If
    End If
  
    Exit Sub
    
error_handler:
    
    MsgBox Err.Description
    
End Sub

'------------------------------------------------------
'this method removes the Add-In from VB
'------------------------------------------------------
Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, custom() As Variant)
    
    On Error Resume Next
    
    'delete the command bar entry
    mcbMenuCommandBar.Delete
    mcbMenuEditCommandBar.Delete
    
    'shut down the Add-In
    If FormDisplayed Then
        SaveSetting App.Title, "Settings", "DisplayOnConnect", "1"
        FormDisplayed = False
    Else
        SaveSetting App.Title, "Settings", "DisplayOnConnect", "0"
    End If
    
    Unload mfrmAddIn
    Set mfrmAddIn = Nothing

End Sub

Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
    If GetSetting(App.Title, "Settings", "DisplayOnConnect", "0") = "1" Then
        'set this to display the form on connect
        Me.Show
    End If
End Sub

Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
'
End Sub

'this event fires when the menu is clicked in the IDE
Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Me.Show
End Sub

Function AddToAddInCommandBar(sCaption As String, Optional IDC_ID As Integer) As Office.CommandBarControl
    Dim cbMenuCommandBar As Office.CommandBarControl  'command bar object
    Dim cbMenu As Object
  
    On Error GoTo AddToAddInCommandBarErr
    
    'see if we can find the Add-Ins menu
    Set cbMenu = VBInstance.CommandBars("Add-Ins")
    If cbMenu Is Nothing Then
        'not available so we fail
        Exit Function
    End If
    
    'add it to the command bar
    Set cbMenuCommandBar = cbMenu.Controls.Add(1)
    'set the caption
    'MsgBox sCaption
    cbMenuCommandBar.Caption = sCaption
    
    On Error Resume Next
    'Clipboard.SetData LoadResPicture(101, vbResBitmap), vbCFBitmap
    Clipboard.SetData frmAddIn.Picture1.Image, vbCFBitmap
    
    cbMenuCommandBar.PasteFace
    Set frmAddIn = Nothing
    
    On Error GoTo 0
    
    Set AddToAddInCommandBar = cbMenuCommandBar
    
    Exit Function
    
AddToAddInCommandBarErr:

End Function

Function AddToEditCommandBar(sCaption As String, Optional IDC_ID As Integer) As Office.CommandBarControl
    
    Dim cbMenuCommandBar As Office.CommandBarControl  'command bar object
    Dim cbMenu As Object
    Dim iRtn As Integer
    
    Const sPROC_NAME As String = "AddToEditCommandBar"
  
    On Error GoTo LocalError
    
    'see if we can find the Add-Ins menu
    Set cbMenu = VBInstance.CommandBars("Edit")
    If cbMenu Is Nothing Then
        'not available so we fail
        Exit Function
    End If
    
    'add it to the command bar
    Set cbMenuCommandBar = cbMenu.Controls.Add(1)
    'set the caption
    'MsgBox sCaption
    cbMenuCommandBar.Caption = sCaption
    
    On Error Resume Next
    'Clipboard.SetData LoadResPicture(101, vbResBitmap), vbCFBitmap
    Clipboard.SetData frmAddIn.Picture1.Image, vbCFBitmap
    
    cbMenuCommandBar.PasteFace
    Set frmAddIn = Nothing
    
    On Error GoTo LocalError
    
    Set AddToEditCommandBar = cbMenuCommandBar
    
Cleanup:
  
    Exit Function
    
LocalError:
    
    Debug.Assert False
    
    iRtn = MsgBox("Error# " & Err.Number & vbNewLine & Err.Description & vbNewLine & _
        "Error on line # " & CStr(Erl) & vbNewLine & "of " & TypeName(Me) & ":" & sPROC_NAME, vbAbortRetryIgnore, "Error - " & App.Title)
    If iRtn = vbRetry Then
        Resume Next
    ElseIf iRtn = vbAbort Then
        GoTo Cleanup
    Else    'vbIgnore
        Resume Next
    End If
    
End Function

Private Sub MenuEditHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
'this event fires when the menu is clicked in the IDE
    Me.Show
End Sub

